/****************************************************************************
*
*	  Module Filename:  Interaction_Type_Support.cpp
*	  Module Name:      Interaction_Type_Support
*	  Description:      Support functions for use with Intearction_Type class
*	  Author:   		Chris Gordon-Smith
*
*     Copyright (C) 2003, 2005, 2006, 2008 Chris Gordon-Smith
*     http://www.simsoup.info/
*
*     This program is free software; you can redistribute it and/or modify it
*     under the terms of the GNU General Public License Version 2, as published 
*     by the Free Software Foundation.
*
*     This program is distributed in the hope that it will be useful, but
*     WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
*     or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
*     for more details.
*
*     You should have received a copy of the GNU General Public License along
*     with this program; if not, write to the Free Software Foundation, Inc.,
*     59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*
*     See the file Licence.txt for a copy of the GNU General Public License.
*
*	  Amendment History:-
*
*		Version	   Date	   			Update Description
*		=======    ===========		==================
*
*
*
*
****************************************************************************/

//	Globally used definitions / declarations

#include "globldef.h"
#include "Library_Headers.h"





//#pragma  hdrstop
//----------------------------------------------------------------------------------------------------------

//	Declarations for Class objects which are members of this Class

//	None


//	Declaration of class implemented by this module

//#include "Interaction_Type_Support.h"


//	Class Declarations for objects constructed by this class


//	Declarations of external classes / functions referenced by this class

#include    "Interaction_Type.h"
#include    "Molecule_Type.h"
#include    "Utility_Functions.h"

//	Include files for Borland C++ Builder built in functions


//	Defines local to this module

//	None

//----------------------------------------------------------------------------------------------------------

//----------------------------------------------------------------------------------------------------------
//std::string Interaction_Type::Support::Convert_Int_Type_Categ_To_Text(Interaction_Type_Enum Interaction_Type_Enumr)

//  Convert an Interaction_Type Category Enumerator to text

//{
//    return(AnsiString__Int_Type_Categ_Names[Interaction_Type_Enumr]);
//}
//----------------------------------------------------------------------------------------------------------
std::string  Interaction_Type::Support::Get_Forward_Rate_Constant_Text(const Interaction_Type*  const Interaction_Type__Ptr)

//  Get a text string for the Interaction_Type's Forward Rate Constant

{
    if(Interaction_Type__Ptr->Get_Reactant1_MolType_Ptr() != NULL)
    THEN
        return(To_String(Interaction_Type__Ptr->Get_Forward_Rate_Constant()));
    ELSE
        Assert(true == false, "Interaction_Type::Support::Get_Forward_Rate_Constant_Text - Invalid Reactant 1");
        return (string(""));
    ENDIF
}
//----------------------------------------------------------------------------------------------------------------

string Interaction_Type::Support::Get_IntType_Summary_As_String(Interaction_Type*  IntType_Ptr)

//  Return a summary of the Interaction Type details as a string

{
    string Reactant2("");
    string Product2("");

    if (IntType_Ptr->Get_Reactant2_MolType_Ptr())
    THEN
        Reactant2 =  string(", Reactant 2 = ")  
                   + To_String(IntType_Ptr->Get_Reactant2_MolType_Ptr()->Get_Identifier());
    ENDIF

    if (IntType_Ptr->Get_Product2_MolType_Ptr())
    THEN
        Product2 =  string(", Product 2 = ")  
                   + To_String(IntType_Ptr->Get_Product2_MolType_Ptr()->Get_Identifier());
    ENDIF
    
    return  IntType_Ptr->Get_Category_As_String() + string(" ")
            + To_String(IntType_Ptr->Get_Identifier()) 
            + string(", Reactant 1 = ")
            + To_String(IntType_Ptr->Get_Reactant1_MolType_Ptr()->Get_Identifier())
            + Reactant2
            + string(", Product 1 = ")
            + To_String(IntType_Ptr->Get_Product1_MolType_Ptr()->Get_Identifier())
            + Product2
            + string(". ");
}
//----------------------------------------------------------------------------------------------------------------

std::string  Interaction_Type::Support::Get_Reverse_Rate_Constant_Text(const Interaction_Type*  const Interaction_Type__Ptr)

//  Get a text string for the Interaction_Type's Reverse Rate Constant

{
    if(Interaction_Type__Ptr->Get_Product1_MolType_Ptr() != NULL)
    THEN
        return(To_String(Interaction_Type__Ptr->Get_Reverse_Rate_Constant()));
    ELSE
        Assert(true == false, "Interaction_Type::Support::Get_Reverse_Rate_Constant_Text - Invalid Product 1");
        return (string(""));
    ENDIF
}
//----------------------------------------------------------------------------------------------------------
std::string  Interaction_Type::Support::Get_Reactant1_Identifier_Text(const Interaction_Type*  const Interaction_Type__Ptr)

//  Get a text string for the Identifier of Reactant1 of the specified Interaction_Type

{
    if(Interaction_Type__Ptr->Get_Reactant1_MolType_Ptr() != NULL)
    THEN
        return(To_String(Interaction_Type__Ptr->Get_Reactant1_MolType_Ptr()->Get_Identifier()));
    ELSE
        return(std::string(""));
    ENDIF
}

//----------------------------------------------------------------------------------------------------------
std::string  Interaction_Type::Support::Get_Reactant2_Identifier_Text(const Interaction_Type*  const Interaction_Type__Ptr)

//  Get a text string for the Identifier of Reactant2 of the specified Interaction_Type

{
    if(Interaction_Type__Ptr->Get_Reactant2_MolType_Ptr() != NULL)
    THEN
        return(To_String(Interaction_Type__Ptr->Get_Reactant2_MolType_Ptr()->Get_Identifier()));
    ELSE
        return(std::string(""));
    ENDIF
}

//----------------------------------------------------------------------------------------------------------

std::string  Interaction_Type::Support::Get_Product1_Identifier_Text(const Interaction_Type*  const Interaction_Type__Ptr)

//  Get a text string for the Identifier of Product1 of the specified Interaction_Type

{
    if(Interaction_Type__Ptr->Get_Product1_MolType_Ptr() != NULL)
    THEN
//      return(AnsiString(Interaction_Type__Ptr->Get_Product1_MolType_Ptr()->Get_Identifier()));
        return(To_String(Interaction_Type__Ptr->Get_Product1_MolType_Ptr()->Get_Identifier()));
    ELSE
        return(std::string(""));
    ENDIF
}

//----------------------------------------------------------------------------------------------------------

std::string  Interaction_Type::Support::Get_Product2_Identifier_Text(const Interaction_Type*  const Interaction_Type__Ptr)

//  Get a text string for the Identifier of Product2 of the specified Interaction_Type

{
    if(Interaction_Type__Ptr->Get_Product2_MolType_Ptr() != NULL)
    THEN
        return(To_String(Interaction_Type__Ptr->Get_Product2_MolType_Ptr()->Get_Identifier()));
    ELSE
        return(std::string(""));
    ENDIF
} 

//----------------------------------------------------------------------------------------------------------
/*
std::string  Interaction_Type::Support::Get_Catalyst_Identifier_Text(const Interaction_Type*  const Interaction_Type__Ptr)

//  Get a text string for the Identifier of Catalyst of the specified Interaction_Type

{
    if(Interaction_Type__Ptr->Get_Catalyst_MolType_Ptr() != NULL)
    THEN
        return(To_String(Interaction_Type__Ptr->Get_Catalyst_MolType_Ptr()->Get_Identifier()));
    ELSE
        return(std::string(""));
    ENDIF
} */
//----------------------------------------------------------------------------------------------------------

