/****************************************************************************
*
*	  Header Filename:  Scenario_Manager.h
*	  Module Name:      Scenario_Manager
*	  Description:      Manager for SimSoup Scenarios
*	  Author:           Chris Gordon-Smith
*
*     Copyright (C) 2005, 2006, 2008 Chris Gordon-Smith
*     Email: See  http://www.simsoup.info
*
*     This program is free software; you can redistribute it and/or modify it
*     under the terms of the GNU General Public License Version 2, as published 
*     by the Free Software Foundation.
*
*     This program is distributed in the hope that it will be useful, but
*     WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
*     or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
*     for more details.
*
*     You should have received a copy of the GNU General Public License along
*     with this program; if not, write to the Free Software Foundation, Inc.,
*     59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*
*     See the file Licence.txt for a copy of the GNU General Public License.
*
*      Amendment History:- 
*
*              Version	  Date                        Update Description
*              =======    ===========                 ==================
*
*
*
*
****************************************************************************/

#ifndef Scenario_Manager_H
#define Scenario_Manager_H

class Scenario;
class Scenario_Series;
class   Scenario_Manager

{
//===== Relationships with other classes ===================================================================
    public:
        Scenario_Series* Get_Curr_Scenario_Series_Ptr();
//==========================================================================================================

    public:
        static Scenario_Manager*  Get_Ptr();
        static void  Make();
//        void   New_Scenario_Series(string& Error_Text);
        bool    Run_Current_Scenario_Series(uint Time_To_Run);
       
    private:
        Scenario_Series* Curr_Scenario_Series_Ptr;
        Scenario_Manager();
        static Scenario_Manager*  Instance_Ptr;
        int Num_Timesteps;   // Number of timesteps for each invokation of the simulation engine
};
#endif  //Scenario_Manager_H
